/*
 *  Utility functions for hat-detect.
 */
#include "art.h"
#include "artutils.h"
#include "detect.h"

void
assert (bool cond, char *act)
{
  if (!cond) {
    fprintf(stderr,"Assertion failed: %s at 0x%x\n",act,q_position);
  }
}

FileOffset
getReductionMain (void)
{
  FileOffset fo,atom,def,use; char c; char *str;
  fseek(HatFileSeq,0x10,SEEK_SET);
  q_fread(&c,sizeof(char),1,HatFileSeq);
  assert (lower5(c)==Module, "Module tag");
  str = q_readString();
  assert (!strcmp(str,"Main"),"Module is Main");
  q_readString();
  atom = q_position;
  q_fread(&c,sizeof(char),1,HatFileSeq);
  assert (lower5(c)==AtomVariable, "AtomVariable tag");
  fo = q_readFO();
  assert (fo==0x10, "AtomVariable module is Main");
  { int x; q_fread(&x,sizeof(int),1,HatFileSeq); }	/* skip defnpos */
  { char x; q_fread(&x,sizeof(char),1,HatFileSeq); }	/* skip fixity */
  q_fread(&c,sizeof(char),1,HatFileSeq);
  assert (c==0, "AtomVariable has arity 0");
  str = q_readString();
  assert (!strcmp(str,"main"),"AtomVariable is main");
  def = q_position;
  q_fread(&c,sizeof(char),1,HatFileSeq);
  assert (lower5(c)==ExpConstDef, "ExpConstDef tag");
  q_readFO(); q_readFO();
  fo = q_readFO();
  assert (fo==atom, "ExpConstDef points to AtomVariable main");
  use = q_position;
  q_fread(&c,sizeof(char),1,HatFileSeq);
  assert (lower5(c)==ExpConstUse, "ExpConstUse tag");
  if (hasSrcPos(tag)) q_readFO();
  q_readFO();
  fo = q_readFO();
  assert(fo==def, "ExpConstUse points to ExpConstDef");
  return use;
}

